Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.velocity.runtime.parser
Class VelocityCharStream

    java.lang.Object
      |
      +--org.apache.velocity.runtime.parser.VelocityCharStream

All Implemented Interfaces:
  CharStream

public final class VelocityCharStream
extends java.lang.Object
implements CharStream

An implementation of interface CharStream, where the stream is assumed to contain only ASCII characters (without unicode processing).

Field Summary
`(package private) int` | `available`
`private int[]` | `bufcolumn`
`private char[]` | `buffer`
`private int[]` | `bufline`
`int` | `bufpos`
`(package private) int` | `bufsize`
`private int` | `column`
`private int` | `inBuf`
`private java.io.Reader` | `inputStream`
`private int` | `line`
`private int` | `maxNextCharInd`
`private boolean` | `prevCharIsCR`
`private boolean` | `prevCharIsLF`
`static boolean` | `staticFlag`
`(package private) int` | `tokenBegin`

Constructor Summary
`VelocityCharStream(java.io.InputStream dstream, int startline, int startcolumn)`
`VelocityCharStream(java.io.InputStream dstream, int startline, int startcolumn, int buffersize)`
`VelocityCharStream(java.io.Reader dstream, int startline, int startcolumn)`
`VelocityCharStream(java.io.Reader dstream, int startline, int startcolumn, int buffersize)`

Method Summary
`void` | `adjustBeginLineColumn(int newLine, int newCol)` Method to adjust line and column numbers for the start of a token.
`void` | `backup(int amount)` Backs up the input stream by amount steps.
`char` | `BeginToken()` Returns the next character that marks the beginning of the next token.
`void` | `Done()` The lexer calls this function to indicate that it is done with the stream and hence implementations can free any resources held by this class.
`private void` | `ExpandBuff(boolean wrapAround)`
`private void` | `FillBuff()`
`int` | `getBeginColumn()` Returns the column number of the first character for current token (being matched after the last call to BeginTOken).
`int` | `getBeginLine()` Returns the line number of the first character for current token (being matched after the last call to BeginTOken).
`int` | `getColumn()` Returns the column position of the character last read.
`int` | `getEndColumn()` Returns the column number of the last character for current token (being matched after the last call to BeginTOken).
`int` | `getEndLine()` Returns the line number of the last character for current token (being matched after the last call to BeginTOken).
`java.lang.String` | `GetImage()` Returns a string made up of characters from the marked token beginning to the current buffer position.
`int` | `getLine()` Returns the line number of the character last read.
`char[]` | `GetSuffix(int len)` Returns an array of characters that make up the suffix of length 'len' for the currently matched token.
`char` | `readChar()` Returns the next character from the selected input.
`void` | `ReInit(java.io.InputStream dstream, int startline, int startcolumn)`
`void` | `ReInit(java.io.InputStream dstream, int startline, int startcolumn, int buffersize)`
`void` | `ReInit(java.io.Reader dstream, int startline, int startcolumn)`
`void` | `ReInit(java.io.Reader dstream, int startline, int startcolumn, int buffersize)`
`private void` | `UpdateLineColumn(char c)`

Methods inherited from class java.lang.Object
`, clone, equals, finalize, getClass, hashCode, notify, notifyAll, registerNatives, toString, wait, wait, wait`

Field Detail

### staticFlag

    public static final boolean staticFlag

### bufsize

    int bufsize

### available

    int available

### tokenBegin

    int tokenBegin

### bufpos

    public int bufpos

### bufline

    private int[] bufline

### bufcolumn

    private int[] bufcolumn

### column

    private int column

### line

    private int line

### prevCharIsCR

    private boolean prevCharIsCR

### prevCharIsLF

    private boolean prevCharIsLF

### inputStream

    private java.io.Reader inputStream

### buffer

    private char[] buffer

### maxNextCharInd

    private int maxNextCharInd

### inBuf

    private int inBuf

Constructor Detail

### VelocityCharStream

    public VelocityCharStream(java.io.Reader dstream,
                              int startline,
                              int startcolumn,
                              int buffersize)

### VelocityCharStream

    public VelocityCharStream(java.io.Reader dstream,
                              int startline,
                              int startcolumn)

### VelocityCharStream

    public VelocityCharStream(java.io.InputStream dstream,
                              int startline,
                              int startcolumn,
                              int buffersize)

### VelocityCharStream

    public VelocityCharStream(java.io.InputStream dstream,
                              int startline,
                              int startcolumn)

Method Detail

### ExpandBuff

    private final void ExpandBuff(boolean wrapAround)

### FillBuff

    private final void FillBuff()
                         throws java.io.IOException

### BeginToken

    public final char BeginToken()
                          throws java.io.IOException

  Description copied from interface: `CharStream`
  Returns the next character that marks the beginning of the next token. All characters must remain in the buffer between two successive calls to this method to implement backup correctly.
  Specified by:
    `BeginToken` in interface `CharStream`

### UpdateLineColumn

    private final void UpdateLineColumn(char c)

### readChar

    public final char readChar()
                        throws java.io.IOException

  Description copied from interface: `CharStream`
  Returns the next character from the selected input. The method of selecting the input is the responsibility of the class implementing this interface. Can throw any java.io.IOException.
  Specified by:
    `readChar` in interface `CharStream`

### getColumn

    public final int getColumn()

  Deprecated.

  Description copied from interface: `CharStream`
  Returns the column position of the character last read.
  Specified by:
    `getColumn` in interface `CharStream`
  See Also:
    `getEndColumn()`

### getLine

    public final int getLine()

  Deprecated.

  Description copied from interface: `CharStream`
  Returns the line number of the character last read.
  Specified by:
    `getLine` in interface `CharStream`
  See Also:
    `getEndLine()`

### getEndColumn

    public final int getEndColumn()

  Description copied from interface: `CharStream`
  Returns the column number of the last character for current token (being matched after the last call to BeginTOken).
  Specified by:
    `getEndColumn` in interface `CharStream`

### getEndLine

    public final int getEndLine()

  Description copied from interface: `CharStream`
  Returns the line number of the last character for current token (being matched after the last call to BeginTOken).
  Specified by:
    `getEndLine` in interface `CharStream`

### getBeginColumn

    public final int getBeginColumn()

  Description copied from interface: `CharStream`
  Returns the column number of the first character for current token (being matched after the last call to BeginTOken).
  Specified by:
    `getBeginColumn` in interface `CharStream`

### getBeginLine

    public final int getBeginLine()

  Description copied from interface: `CharStream`
  Returns the line number of the first character for current token (being matched after the last call to BeginTOken).
  Specified by:
    `getBeginLine` in interface `CharStream`

### backup

    public final void backup(int amount)

  Description copied from interface: `CharStream`
  Backs up the input stream by amount steps. Lexer calls this method if it had already read some characters, but could not use them to match a (longer) token. So, they will be used again as the prefix of the next token and it is the implemetation's responsibility to do this right.
  Specified by:
    `backup` in interface `CharStream`

### ReInit

    public void ReInit(java.io.Reader dstream,
                       int startline,
                       int startcolumn,
                       int buffersize)

### ReInit

    public void ReInit(java.io.Reader dstream,
                       int startline,
                       int startcolumn)

### ReInit

    public void ReInit(java.io.InputStream dstream,
                       int startline,
                       int startcolumn,
                       int buffersize)

### ReInit

    public void ReInit(java.io.InputStream dstream,
                       int startline,
                       int startcolumn)

### GetImage

    public final java.lang.String GetImage()

  Description copied from interface: `CharStream`
  Returns a string made up of characters from the marked token beginning to the current buffer position. Implementations have the choice of returning anything that they want to. For example, for efficiency, one might decide to just return null, which is a valid implementation.
  Specified by:
    `GetImage` in interface `CharStream`

### GetSuffix

    public final char[] GetSuffix(int len)

  Description copied from interface: `CharStream`
  Returns an array of characters that make up the suffix of length 'len' for the currently matched token. This is used to build up the matched string for use in actions in the case of MORE. A simple and inefficient implementation of this is as follows : { String t = GetImage(); return t.substring(t.length() - len, t.length()).toCharArray(); }
  Specified by:
    `GetSuffix` in interface `CharStream`

### Done

    public void Done()

  Description copied from interface: `CharStream`
  The lexer calls this function to indicate that it is done with the stream and hence implementations can free any resources held by this class. Again, the body of this function can be just empty and it will not affect the lexer's operation.
  Specified by:
    `Done` in interface `CharStream`

### adjustBeginLineColumn

    public void adjustBeginLineColumn(int newLine,
                                      int newCol)

  Method to adjust line and column numbers for the start of a token.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003 Apache Software Foundation. All Rights Reserved.